/*
  Copyright 1993-2008 Medical Image Processing Group
              Department of Radiology
            University of Pennsylvania

This file is part of CAVASS.

CAVASS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CAVASS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CAVASS.  If not, see <http://www.gnu.org/licenses/>.

*/

 
 
#define CIRCLES 35

int circle_no_points[CIRCLES]={
    1,
    4,
    8,
   16,
   20,
   32,
   32,
   36,
   48,
   56,
   64,
   60,
   64,
   88,
   84,
   96,
   88,
  104,
  108,
  120,
  128,
  116,
  144,
  136,
  140,
  168,
  160,
  168,
  164,
  176,
  192,
  180,
  208,
  200,
  216};

int (*circle_points[CIRCLES])[2];

int circle_points_data[][2]={
{  0,   0},
{ -1,   0},
{  0,  -1},
{  0,   1},
{  1,   0},
{ -2,   0},
{ -1,  -1},
{ -1,   1},
{  0,  -2},
{  0,   2},
{  1,  -1},
{  1,   1},
{  2,   0},
{ -3,   0},
{ -2,  -2},
{ -2,  -1},
{ -2,   1},
{ -2,   2},
{ -1,  -2},
{ -1,   2},
{  0,  -3},
{  0,   3},
{  1,  -2},
{  1,   2},
{  2,  -2},
{  2,  -1},
{  2,   1},
{  2,   2},
{  3,   0},
{ -4,   0},
{ -3,  -2},
{ -3,  -1},
{ -3,   1},
{ -3,   2},
{ -2,  -3},
{ -2,   3},
{ -1,  -3},
{ -1,   3},
{  0,  -4},
{  0,   4},
{  1,  -3},
{  1,   3},
{  2,  -3},
{  2,   3},
{  3,  -2},
{  3,  -1},
{  3,   1},
{  3,   2},
{  4,   0},
{ -5,   0},
{ -4,  -3},
{ -4,  -2},
{ -4,  -1},
{ -4,   1},
{ -4,   2},
{ -4,   3},
{ -3,  -4},
{ -3,  -3},
{ -3,   3},
{ -3,   4},
{ -2,  -4},
{ -2,   4},
{ -1,  -4},
{ -1,   4},
{  0,  -5},
{  0,   5},
{  1,  -4},
{  1,   4},
{  2,  -4},
{  2,   4},
{  3,  -4},
{  3,  -3},
{  3,   3},
{  3,   4},
{  4,  -3},
{  4,  -2},
{  4,  -1},
{  4,   1},
{  4,   2},
{  4,   3},
{  5,   0},
{ -6,   0},
{ -5,  -3},
{ -5,  -2},
{ -5,  -1},
{ -5,   1},
{ -5,   2},
{ -5,   3},
{ -4,  -4},
{ -4,   4},
{ -3,  -5},
{ -3,   5},
{ -2,  -5},
{ -2,   5},
{ -1,  -5},
{ -1,   5},
{  0,  -6},
{  0,   6},
{  1,  -5},
{  1,   5},
{  2,  -5},
{  2,   5},
{  3,  -5},
{  3,   5},
{  4,  -4},
{  4,   4},
{  5,  -3},
{  5,  -2},
{  5,  -1},
{  5,   1},
{  5,   2},
{  5,   3},
{  6,   0},
{ -7,   0},
{ -6,  -3},
{ -6,  -2},
{ -6,  -1},
{ -6,   1},
{ -6,   2},
{ -6,   3},
{ -5,  -4},
{ -5,   4},
{ -4,  -5},
{ -4,   5},
{ -3,  -6},
{ -3,   6},
{ -2,  -6},
{ -2,   6},
{ -1,  -6},
{ -1,   6},
{  0,  -7},
{  0,   7},
{  1,  -6},
{  1,   6},
{  2,  -6},
{  2,   6},
{  3,  -6},
{  3,   6},
{  4,  -5},
{  4,   5},
{  5,  -4},
{  5,   4},
{  6,  -3},
{  6,  -2},
{  6,  -1},
{  6,   1},
{  6,   2},
{  6,   3},
{  7,   0},
{ -8,   0},
{ -7,  -3},
{ -7,  -2},
{ -7,  -1},
{ -7,   1},
{ -7,   2},
{ -7,   3},
{ -6,  -5},
{ -6,  -4},
{ -6,   4},
{ -6,   5},
{ -5,  -6},
{ -5,  -5},
{ -5,   5},
{ -5,   6},
{ -4,  -6},
{ -4,   6},
{ -3,  -7},
{ -3,   7},
{ -2,  -7},
{ -2,   7},
{ -1,  -7},
{ -1,   7},
{  0,  -8},
{  0,   8},
{  1,  -7},
{  1,   7},
{  2,  -7},
{  2,   7},
{  3,  -7},
{  3,   7},
{  4,  -6},
{  4,   6},
{  5,  -6},
{  5,  -5},
{  5,   5},
{  5,   6},
{  6,  -5},
{  6,  -4},
{  6,   4},
{  6,   5},
{  7,  -3},
{  7,  -2},
{  7,  -1},
{  7,   1},
{  7,   2},
{  7,   3},
{  8,   0},
{ -9,   0},
{ -8,  -4},
{ -8,  -3},
{ -8,  -2},
{ -8,  -1},
{ -8,   1},
{ -8,   2},
{ -8,   3},
{ -8,   4},
{ -7,  -5},
{ -7,  -4},
{ -7,   4},
{ -7,   5},
{ -6,  -6},
{ -6,   6},
{ -5,  -7},
{ -5,   7},
{ -4,  -8},
{ -4,  -7},
{ -4,   7},
{ -4,   8},
{ -3,  -8},
{ -3,   8},
{ -2,  -8},
{ -2,   8},
{ -1,  -8},
{ -1,   8},
{  0,  -9},
{  0,   9},
{  1,  -8},
{  1,   8},
{  2,  -8},
{  2,   8},
{  3,  -8},
{  3,   8},
{  4,  -8},
{  4,  -7},
{  4,   7},
{  4,   8},
{  5,  -7},
{  5,   7},
{  6,  -6},
{  6,   6},
{  7,  -5},
{  7,  -4},
{  7,   4},
{  7,   5},
{  8,  -4},
{  8,  -3},
{  8,  -2},
{  8,  -1},
{  8,   1},
{  8,   2},
{  8,   3},
{  8,   4},
{  9,   0},
{-10,   0},
{ -9,  -4},
{ -9,  -3},
{ -9,  -2},
{ -9,  -1},
{ -9,   1},
{ -9,   2},
{ -9,   3},
{ -9,   4},
{ -8,  -6},
{ -8,  -5},
{ -8,   5},
{ -8,   6},
{ -7,  -7},
{ -7,  -6},
{ -7,   6},
{ -7,   7},
{ -6,  -8},
{ -6,  -7},
{ -6,   7},
{ -6,   8},
{ -5,  -8},
{ -5,   8},
{ -4,  -9},
{ -4,   9},
{ -3,  -9},
{ -3,   9},
{ -2,  -9},
{ -2,   9},
{ -1,  -9},
{ -1,   9},
{  0, -10},
{  0,  10},
{  1,  -9},
{  1,   9},
{  2,  -9},
{  2,   9},
{  3,  -9},
{  3,   9},
{  4,  -9},
{  4,   9},
{  5,  -8},
{  5,   8},
{  6,  -8},
{  6,  -7},
{  6,   7},
{  6,   8},
{  7,  -7},
{  7,  -6},
{  7,   6},
{  7,   7},
{  8,  -6},
{  8,  -5},
{  8,   5},
{  8,   6},
{  9,  -4},
{  9,  -3},
{  9,  -2},
{  9,  -1},
{  9,   1},
{  9,   2},
{  9,   3},
{  9,   4},
{ 10,   0},
{-11,   0},
{-10,  -4},
{-10,  -3},
{-10,  -2},
{-10,  -1},
{-10,   1},
{-10,   2},
{-10,   3},
{-10,   4},
{ -9,  -6},
{ -9,  -5},
{ -9,   5},
{ -9,   6},
{ -8,  -7},
{ -8,   7},
{ -7,  -8},
{ -7,   8},
{ -6,  -9},
{ -6,   9},
{ -5,  -9},
{ -5,   9},
{ -4, -10},
{ -4,  10},
{ -3, -10},
{ -3,  10},
{ -2, -10},
{ -2,  10},
{ -1, -10},
{ -1,  10},
{  0, -11},
{  0,  11},
{  1, -10},
{  1,  10},
{  2, -10},
{  2,  10},
{  3, -10},
{  3,  10},
{  4, -10},
{  4,  10},
{  5,  -9},
{  5,   9},
{  6,  -9},
{  6,   9},
{  7,  -8},
{  7,   8},
{  8,  -7},
{  8,   7},
{  9,  -6},
{  9,  -5},
{  9,   5},
{  9,   6},
{ 10,  -4},
{ 10,  -3},
{ 10,  -2},
{ 10,  -1},
{ 10,   1},
{ 10,   2},
{ 10,   3},
{ 10,   4},
{ 11,   0},
{-12,   0},
{-11,  -4},
{-11,  -3},
{-11,  -2},
{-11,  -1},
{-11,   1},
{-11,   2},
{-11,   3},
{-11,   4},
{-10,  -6},
{-10,  -5},
{-10,   5},
{-10,   6},
{ -9,  -7},
{ -9,   7},
{ -8,  -8},
{ -8,   8},
{ -7,  -9},
{ -7,   9},
{ -6, -10},
{ -6,  10},
{ -5, -10},
{ -5,  10},
{ -4, -11},
{ -4,  11},
{ -3, -11},
{ -3,  11},
{ -2, -11},
{ -2,  11},
{ -1, -11},
{ -1,  11},
{  0, -12},
{  0,  12},
{  1, -11},
{  1,  11},
{  2, -11},
{  2,  11},
{  3, -11},
{  3,  11},
{  4, -11},
{  4,  11},
{  5, -10},
{  5,  10},
{  6, -10},
{  6,  10},
{  7,  -9},
{  7,   9},
{  8,  -8},
{  8,   8},
{  9,  -7},
{  9,   7},
{ 10,  -6},
{ 10,  -5},
{ 10,   5},
{ 10,   6},
{ 11,  -4},
{ 11,  -3},
{ 11,  -2},
{ 11,  -1},
{ 11,   1},
{ 11,   2},
{ 11,   3},
{ 11,   4},
{ 12,   0},
{-13,   0},
{-12,  -5},
{-12,  -4},
{-12,  -3},
{-12,  -2},
{-12,  -1},
{-12,   1},
{-12,   2},
{-12,   3},
{-12,   4},
{-12,   5},
{-11,  -6},
{-11,  -5},
{-11,   5},
{-11,   6},
{-10,  -8},
{-10,  -7},
{-10,   7},
{-10,   8},
{ -9,  -9},
{ -9,  -8},
{ -9,   8},
{ -9,   9},
{ -8, -10},
{ -8,  -9},
{ -8,   9},
{ -8,  10},
{ -7, -10},
{ -7,  10},
{ -6, -11},
{ -6,  11},
{ -5, -12},
{ -5, -11},
{ -5,  11},
{ -5,  12},
{ -4, -12},
{ -4,  12},
{ -3, -12},
{ -3,  12},
{ -2, -12},
{ -2,  12},
{ -1, -12},
{ -1,  12},
{  0, -13},
{  0,  13},
{  1, -12},
{  1,  12},
{  2, -12},
{  2,  12},
{  3, -12},
{  3,  12},
{  4, -12},
{  4,  12},
{  5, -12},
{  5, -11},
{  5,  11},
{  5,  12},
{  6, -11},
{  6,  11},
{  7, -10},
{  7,  10},
{  8, -10},
{  8,  -9},
{  8,   9},
{  8,  10},
{  9,  -9},
{  9,  -8},
{  9,   8},
{  9,   9},
{ 10,  -8},
{ 10,  -7},
{ 10,   7},
{ 10,   8},
{ 11,  -6},
{ 11,  -5},
{ 11,   5},
{ 11,   6},
{ 12,  -5},
{ 12,  -4},
{ 12,  -3},
{ 12,  -2},
{ 12,  -1},
{ 12,   1},
{ 12,   2},
{ 12,   3},
{ 12,   4},
{ 12,   5},
{ 13,   0},
{-14,   0},
{-13,  -5},
{-13,  -4},
{-13,  -3},
{-13,  -2},
{-13,  -1},
{-13,   1},
{-13,   2},
{-13,   3},
{-13,   4},
{-13,   5},
{-12,  -7},
{-12,  -6},
{-12,   6},
{-12,   7},
{-11,  -8},
{-11,  -7},
{-11,   7},
{-11,   8},
{-10,  -9},
{-10,   9},
{ -9, -10},
{ -9,  10},
{ -8, -11},
{ -8,  11},
{ -7, -12},
{ -7, -11},
{ -7,  11},
{ -7,  12},
{ -6, -12},
{ -6,  12},
{ -5, -13},
{ -5,  13},
{ -4, -13},
{ -4,  13},
{ -3, -13},
{ -3,  13},
{ -2, -13},
{ -2,  13},
{ -1, -13},
{ -1,  13},
{  0, -14},
{  0,  14},
{  1, -13},
{  1,  13},
{  2, -13},
{  2,  13},
{  3, -13},
{  3,  13},
{  4, -13},
{  4,  13},
{  5, -13},
{  5,  13},
{  6, -12},
{  6,  12},
{  7, -12},
{  7, -11},
{  7,  11},
{  7,  12},
{  8, -11},
{  8,  11},
{  9, -10},
{  9,  10},
{ 10,  -9},
{ 10,   9},
{ 11,  -8},
{ 11,  -7},
{ 11,   7},
{ 11,   8},
{ 12,  -7},
{ 12,  -6},
{ 12,   6},
{ 12,   7},
{ 13,  -5},
{ 13,  -4},
{ 13,  -3},
{ 13,  -2},
{ 13,  -1},
{ 13,   1},
{ 13,   2},
{ 13,   3},
{ 13,   4},
{ 13,   5},
{ 14,   0},
{-15,   0},
{-14,  -5},
{-14,  -4},
{-14,  -3},
{-14,  -2},
{-14,  -1},
{-14,   1},
{-14,   2},
{-14,   3},
{-14,   4},
{-14,   5},
{-13,  -7},
{-13,  -6},
{-13,   6},
{-13,   7},
{-12,  -9},
{-12,  -8},
{-12,   8},
{-12,   9},
{-11, -10},
{-11,  -9},
{-11,   9},
{-11,  10},
{-10, -11},
{-10, -10},
{-10,  10},
{-10,  11},
{ -9, -12},
{ -9, -11},
{ -9,  11},
{ -9,  12},
{ -8, -12},
{ -8,  12},
{ -7, -13},
{ -7,  13},
{ -6, -13},
{ -6,  13},
{ -5, -14},
{ -5,  14},
{ -4, -14},
{ -4,  14},
{ -3, -14},
{ -3,  14},
{ -2, -14},
{ -2,  14},
{ -1, -14},
{ -1,  14},
{  0, -15},
{  0,  15},
{  1, -14},
{  1,  14},
{  2, -14},
{  2,  14},
{  3, -14},
{  3,  14},
{  4, -14},
{  4,  14},
{  5, -14},
{  5,  14},
{  6, -13},
{  6,  13},
{  7, -13},
{  7,  13},
{  8, -12},
{  8,  12},
{  9, -12},
{  9, -11},
{  9,  11},
{  9,  12},
{ 10, -11},
{ 10, -10},
{ 10,  10},
{ 10,  11},
{ 11, -10},
{ 11,  -9},
{ 11,   9},
{ 11,  10},
{ 12,  -9},
{ 12,  -8},
{ 12,   8},
{ 12,   9},
{ 13,  -7},
{ 13,  -6},
{ 13,   6},
{ 13,   7},
{ 14,  -5},
{ 14,  -4},
{ 14,  -3},
{ 14,  -2},
{ 14,  -1},
{ 14,   1},
{ 14,   2},
{ 14,   3},
{ 14,   4},
{ 14,   5},
{ 15,   0},
{-16,   0},
{-15,  -5},
{-15,  -4},
{-15,  -3},
{-15,  -2},
{-15,  -1},
{-15,   1},
{-15,   2},
{-15,   3},
{-15,   4},
{-15,   5},
{-14,  -7},
{-14,  -6},
{-14,   6},
{-14,   7},
{-13,  -9},
{-13,  -8},
{-13,   8},
{-13,   9},
{-12, -10},
{-12,  10},
{-11, -11},
{-11,  11},
{-10, -12},
{-10,  12},
{ -9, -13},
{ -9,  13},
{ -8, -13},
{ -8,  13},
{ -7, -14},
{ -7,  14},
{ -6, -14},
{ -6,  14},
{ -5, -15},
{ -5,  15},
{ -4, -15},
{ -4,  15},
{ -3, -15},
{ -3,  15},
{ -2, -15},
{ -2,  15},
{ -1, -15},
{ -1,  15},
{  0, -16},
{  0,  16},
{  1, -15},
{  1,  15},
{  2, -15},
{  2,  15},
{  3, -15},
{  3,  15},
{  4, -15},
{  4,  15},
{  5, -15},
{  5,  15},
{  6, -14},
{  6,  14},
{  7, -14},
{  7,  14},
{  8, -13},
{  8,  13},
{  9, -13},
{  9,  13},
{ 10, -12},
{ 10,  12},
{ 11, -11},
{ 11,  11},
{ 12, -10},
{ 12,  10},
{ 13,  -9},
{ 13,  -8},
{ 13,   8},
{ 13,   9},
{ 14,  -7},
{ 14,  -6},
{ 14,   6},
{ 14,   7},
{ 15,  -5},
{ 15,  -4},
{ 15,  -3},
{ 15,  -2},
{ 15,  -1},
{ 15,   1},
{ 15,   2},
{ 15,   3},
{ 15,   4},
{ 15,   5},
{ 16,   0},
{-17,   0},
{-16,  -5},
{-16,  -4},
{-16,  -3},
{-16,  -2},
{-16,  -1},
{-16,   1},
{-16,   2},
{-16,   3},
{-16,   4},
{-16,   5},
{-15,  -8},
{-15,  -7},
{-15,  -6},
{-15,   6},
{-15,   7},
{-15,   8},
{-14,  -9},
{-14,  -8},
{-14,   8},
{-14,   9},
{-13, -10},
{-13,  10},
{-12, -12},
{-12, -11},
{-12,  11},
{-12,  12},
{-11, -12},
{-11,  12},
{-10, -13},
{-10,  13},
{ -9, -14},
{ -9,  14},
{ -8, -15},
{ -8, -14},
{ -8,  14},
{ -8,  15},
{ -7, -15},
{ -7,  15},
{ -6, -15},
{ -6,  15},
{ -5, -16},
{ -5,  16},
{ -4, -16},
{ -4,  16},
{ -3, -16},
{ -3,  16},
{ -2, -16},
{ -2,  16},
{ -1, -16},
{ -1,  16},
{  0, -17},
{  0,  17},
{  1, -16},
{  1,  16},
{  2, -16},
{  2,  16},
{  3, -16},
{  3,  16},
{  4, -16},
{  4,  16},
{  5, -16},
{  5,  16},
{  6, -15},
{  6,  15},
{  7, -15},
{  7,  15},
{  8, -15},
{  8, -14},
{  8,  14},
{  8,  15},
{  9, -14},
{  9,  14},
{ 10, -13},
{ 10,  13},
{ 11, -12},
{ 11,  12},
{ 12, -12},
{ 12, -11},
{ 12,  11},
{ 12,  12},
{ 13, -10},
{ 13,  10},
{ 14,  -9},
{ 14,  -8},
{ 14,   8},
{ 14,   9},
{ 15,  -8},
{ 15,  -7},
{ 15,  -6},
{ 15,   6},
{ 15,   7},
{ 15,   8},
{ 16,  -5},
{ 16,  -4},
{ 16,  -3},
{ 16,  -2},
{ 16,  -1},
{ 16,   1},
{ 16,   2},
{ 16,   3},
{ 16,   4},
{ 16,   5},
{ 17,   0},
{-18,   0},
{-17,  -5},
{-17,  -4},
{-17,  -3},
{-17,  -2},
{-17,  -1},
{-17,   1},
{-17,   2},
{-17,   3},
{-17,   4},
{-17,   5},
{-16,  -8},
{-16,  -7},
{-16,  -6},
{-16,   6},
{-16,   7},
{-16,   8},
{-15,  -9},
{-15,   9},
{-14, -11},
{-14, -10},
{-14,  10},
{-14,  11},
{-13, -12},
{-13, -11},
{-13,  11},
{-13,  12},
{-12, -13},
{-12,  13},
{-11, -14},
{-11, -13},
{-11,  13},
{-11,  14},
{-10, -14},
{-10,  14},
{ -9, -15},
{ -9,  15},
{ -8, -16},
{ -8,  16},
{ -7, -16},
{ -7,  16},
{ -6, -16},
{ -6,  16},
{ -5, -17},
{ -5,  17},
{ -4, -17},
{ -4,  17},
{ -3, -17},
{ -3,  17},
{ -2, -17},
{ -2,  17},
{ -1, -17},
{ -1,  17},
{  0, -18},
{  0,  18},
{  1, -17},
{  1,  17},
{  2, -17},
{  2,  17},
{  3, -17},
{  3,  17},
{  4, -17},
{  4,  17},
{  5, -17},
{  5,  17},
{  6, -16},
{  6,  16},
{  7, -16},
{  7,  16},
{  8, -16},
{  8,  16},
{  9, -15},
{  9,  15},
{ 10, -14},
{ 10,  14},
{ 11, -14},
{ 11, -13},
{ 11,  13},
{ 11,  14},
{ 12, -13},
{ 12,  13},
{ 13, -12},
{ 13, -11},
{ 13,  11},
{ 13,  12},
{ 14, -11},
{ 14, -10},
{ 14,  10},
{ 14,  11},
{ 15,  -9},
{ 15,   9},
{ 16,  -8},
{ 16,  -7},
{ 16,  -6},
{ 16,   6},
{ 16,   7},
{ 16,   8},
{ 17,  -5},
{ 17,  -4},
{ 17,  -3},
{ 17,  -2},
{ 17,  -1},
{ 17,   1},
{ 17,   2},
{ 17,   3},
{ 17,   4},
{ 17,   5},
{ 18,   0},
{-19,   0},
{-18,  -6},
{-18,  -5},
{-18,  -4},
{-18,  -3},
{-18,  -2},
{-18,  -1},
{-18,   1},
{-18,   2},
{-18,   3},
{-18,   4},
{-18,   5},
{-18,   6},
{-17,  -8},
{-17,  -7},
{-17,  -6},
{-17,   6},
{-17,   7},
{-17,   8},
{-16, -10},
{-16,  -9},
{-16,   9},
{-16,  10},
{-15, -11},
{-15, -10},
{-15,  10},
{-15,  11},
{-14, -12},
{-14,  12},
{-13, -13},
{-13,  13},
{-12, -14},
{-12,  14},
{-11, -15},
{-11,  15},
{-10, -16},
{-10, -15},
{-10,  15},
{-10,  16},
{ -9, -16},
{ -9,  16},
{ -8, -17},
{ -8,  17},
{ -7, -17},
{ -7,  17},
{ -6, -18},
{ -6, -17},
{ -6,  17},
{ -6,  18},
{ -5, -18},
{ -5,  18},
{ -4, -18},
{ -4,  18},
{ -3, -18},
{ -3,  18},
{ -2, -18},
{ -2,  18},
{ -1, -18},
{ -1,  18},
{  0, -19},
{  0,  19},
{  1, -18},
{  1,  18},
{  2, -18},
{  2,  18},
{  3, -18},
{  3,  18},
{  4, -18},
{  4,  18},
{  5, -18},
{  5,  18},
{  6, -18},
{  6, -17},
{  6,  17},
{  6,  18},
{  7, -17},
{  7,  17},
{  8, -17},
{  8,  17},
{  9, -16},
{  9,  16},
{ 10, -16},
{ 10, -15},
{ 10,  15},
{ 10,  16},
{ 11, -15},
{ 11,  15},
{ 12, -14},
{ 12,  14},
{ 13, -13},
{ 13,  13},
{ 14, -12},
{ 14,  12},
{ 15, -11},
{ 15, -10},
{ 15,  10},
{ 15,  11},
{ 16, -10},
{ 16,  -9},
{ 16,   9},
{ 16,  10},
{ 17,  -8},
{ 17,  -7},
{ 17,  -6},
{ 17,   6},
{ 17,   7},
{ 17,   8},
{ 18,  -6},
{ 18,  -5},
{ 18,  -4},
{ 18,  -3},
{ 18,  -2},
{ 18,  -1},
{ 18,   1},
{ 18,   2},
{ 18,   3},
{ 18,   4},
{ 18,   5},
{ 18,   6},
{ 19,   0},
{-20,   0},
{-19,  -6},
{-19,  -5},
{-19,  -4},
{-19,  -3},
{-19,  -2},
{-19,  -1},
{-19,   1},
{-19,   2},
{-19,   3},
{-19,   4},
{-19,   5},
{-19,   6},
{-18,  -8},
{-18,  -7},
{-18,   7},
{-18,   8},
{-17, -10},
{-17,  -9},
{-17,   9},
{-17,  10},
{-16, -12},
{-16, -11},
{-16,  11},
{-16,  12},
{-15, -13},
{-15, -12},
{-15,  12},
{-15,  13},
{-14, -14},
{-14, -13},
{-14,  13},
{-14,  14},
{-13, -15},
{-13, -14},
{-13,  14},
{-13,  15},
{-12, -16},
{-12, -15},
{-12,  15},
{-12,  16},
{-11, -16},
{-11,  16},
{-10, -17},
{-10,  17},
{ -9, -17},
{ -9,  17},
{ -8, -18},
{ -8,  18},
{ -7, -18},
{ -7,  18},
{ -6, -19},
{ -6,  19},
{ -5, -19},
{ -5,  19},
{ -4, -19},
{ -4,  19},
{ -3, -19},
{ -3,  19},
{ -2, -19},
{ -2,  19},
{ -1, -19},
{ -1,  19},
{  0, -20},
{  0,  20},
{  1, -19},
{  1,  19},
{  2, -19},
{  2,  19},
{  3, -19},
{  3,  19},
{  4, -19},
{  4,  19},
{  5, -19},
{  5,  19},
{  6, -19},
{  6,  19},
{  7, -18},
{  7,  18},
{  8, -18},
{  8,  18},
{  9, -17},
{  9,  17},
{ 10, -17},
{ 10,  17},
{ 11, -16},
{ 11,  16},
{ 12, -16},
{ 12, -15},
{ 12,  15},
{ 12,  16},
{ 13, -15},
{ 13, -14},
{ 13,  14},
{ 13,  15},
{ 14, -14},
{ 14, -13},
{ 14,  13},
{ 14,  14},
{ 15, -13},
{ 15, -12},
{ 15,  12},
{ 15,  13},
{ 16, -12},
{ 16, -11},
{ 16,  11},
{ 16,  12},
{ 17, -10},
{ 17,  -9},
{ 17,   9},
{ 17,  10},
{ 18,  -8},
{ 18,  -7},
{ 18,   7},
{ 18,   8},
{ 19,  -6},
{ 19,  -5},
{ 19,  -4},
{ 19,  -3},
{ 19,  -2},
{ 19,  -1},
{ 19,   1},
{ 19,   2},
{ 19,   3},
{ 19,   4},
{ 19,   5},
{ 19,   6},
{ 20,   0},
{-21,   0},
{-20,  -6},
{-20,  -5},
{-20,  -4},
{-20,  -3},
{-20,  -2},
{-20,  -1},
{-20,   1},
{-20,   2},
{-20,   3},
{-20,   4},
{-20,   5},
{-20,   6},
{-19,  -8},
{-19,  -7},
{-19,   7},
{-19,   8},
{-18, -10},
{-18,  -9},
{-18,   9},
{-18,  10},
{-17, -12},
{-17, -11},
{-17,  11},
{-17,  12},
{-16, -13},
{-16,  13},
{-15, -14},
{-15,  14},
{-14, -15},
{-14,  15},
{-13, -16},
{-13,  16},
{-12, -17},
{-12,  17},
{-11, -17},
{-11,  17},
{-10, -18},
{-10,  18},
{ -9, -18},
{ -9,  18},
{ -8, -19},
{ -8,  19},
{ -7, -19},
{ -7,  19},
{ -6, -20},
{ -6,  20},
{ -5, -20},
{ -5,  20},
{ -4, -20},
{ -4,  20},
{ -3, -20},
{ -3,  20},
{ -2, -20},
{ -2,  20},
{ -1, -20},
{ -1,  20},
{  0, -21},
{  0,  21},
{  1, -20},
{  1,  20},
{  2, -20},
{  2,  20},
{  3, -20},
{  3,  20},
{  4, -20},
{  4,  20},
{  5, -20},
{  5,  20},
{  6, -20},
{  6,  20},
{  7, -19},
{  7,  19},
{  8, -19},
{  8,  19},
{  9, -18},
{  9,  18},
{ 10, -18},
{ 10,  18},
{ 11, -17},
{ 11,  17},
{ 12, -17},
{ 12,  17},
{ 13, -16},
{ 13,  16},
{ 14, -15},
{ 14,  15},
{ 15, -14},
{ 15,  14},
{ 16, -13},
{ 16,  13},
{ 17, -12},
{ 17, -11},
{ 17,  11},
{ 17,  12},
{ 18, -10},
{ 18,  -9},
{ 18,   9},
{ 18,  10},
{ 19,  -8},
{ 19,  -7},
{ 19,   7},
{ 19,   8},
{ 20,  -6},
{ 20,  -5},
{ 20,  -4},
{ 20,  -3},
{ 20,  -2},
{ 20,  -1},
{ 20,   1},
{ 20,   2},
{ 20,   3},
{ 20,   4},
{ 20,   5},
{ 20,   6},
{ 21,   0},
{-22,   0},
{-21,  -6},
{-21,  -5},
{-21,  -4},
{-21,  -3},
{-21,  -2},
{-21,  -1},
{-21,   1},
{-21,   2},
{-21,   3},
{-21,   4},
{-21,   5},
{-21,   6},
{-20,  -9},
{-20,  -8},
{-20,  -7},
{-20,   7},
{-20,   8},
{-20,   9},
{-19, -11},
{-19, -10},
{-19,  -9},
{-19,   9},
{-19,  10},
{-19,  11},
{-18, -12},
{-18, -11},
{-18,  11},
{-18,  12},
{-17, -13},
{-17,  13},
{-16, -15},
{-16, -14},
{-16,  14},
{-16,  15},
{-15, -16},
{-15, -15},
{-15,  15},
{-15,  16},
{-14, -16},
{-14,  16},
{-13, -17},
{-13,  17},
{-12, -18},
{-12,  18},
{-11, -19},
{-11, -18},
{-11,  18},
{-11,  19},
{-10, -19},
{-10,  19},
{ -9, -20},
{ -9, -19},
{ -9,  19},
{ -9,  20},
{ -8, -20},
{ -8,  20},
{ -7, -20},
{ -7,  20},
{ -6, -21},
{ -6,  21},
{ -5, -21},
{ -5,  21},
{ -4, -21},
{ -4,  21},
{ -3, -21},
{ -3,  21},
{ -2, -21},
{ -2,  21},
{ -1, -21},
{ -1,  21},
{  0, -22},
{  0,  22},
{  1, -21},
{  1,  21},
{  2, -21},
{  2,  21},
{  3, -21},
{  3,  21},
{  4, -21},
{  4,  21},
{  5, -21},
{  5,  21},
{  6, -21},
{  6,  21},
{  7, -20},
{  7,  20},
{  8, -20},
{  8,  20},
{  9, -20},
{  9, -19},
{  9,  19},
{  9,  20},
{ 10, -19},
{ 10,  19},
{ 11, -19},
{ 11, -18},
{ 11,  18},
{ 11,  19},
{ 12, -18},
{ 12,  18},
{ 13, -17},
{ 13,  17},
{ 14, -16},
{ 14,  16},
{ 15, -16},
{ 15, -15},
{ 15,  15},
{ 15,  16},
{ 16, -15},
{ 16, -14},
{ 16,  14},
{ 16,  15},
{ 17, -13},
{ 17,  13},
{ 18, -12},
{ 18, -11},
{ 18,  11},
{ 18,  12},
{ 19, -11},
{ 19, -10},
{ 19,  -9},
{ 19,   9},
{ 19,  10},
{ 19,  11},
{ 20,  -9},
{ 20,  -8},
{ 20,  -7},
{ 20,   7},
{ 20,   8},
{ 20,   9},
{ 21,  -6},
{ 21,  -5},
{ 21,  -4},
{ 21,  -3},
{ 21,  -2},
{ 21,  -1},
{ 21,   1},
{ 21,   2},
{ 21,   3},
{ 21,   4},
{ 21,   5},
{ 21,   6},
{ 22,   0},
{-23,   0},
{-22,  -6},
{-22,  -5},
{-22,  -4},
{-22,  -3},
{-22,  -2},
{-22,  -1},
{-22,   1},
{-22,   2},
{-22,   3},
{-22,   4},
{-22,   5},
{-22,   6},
{-21,  -9},
{-21,  -8},
{-21,  -7},
{-21,   7},
{-21,   8},
{-21,   9},
{-20, -11},
{-20, -10},
{-20,  10},
{-20,  11},
{-19, -12},
{-19,  12},
{-18, -14},
{-18, -13},
{-18,  13},
{-18,  14},
{-17, -15},
{-17, -14},
{-17,  14},
{-17,  15},
{-16, -16},
{-16,  16},
{-15, -17},
{-15,  17},
{-14, -18},
{-14, -17},
{-14,  17},
{-14,  18},
{-13, -18},
{-13,  18},
{-12, -19},
{-12,  19},
{-11, -20},
{-11,  20},
{-10, -20},
{-10,  20},
{ -9, -21},
{ -9,  21},
{ -8, -21},
{ -8,  21},
{ -7, -21},
{ -7,  21},
{ -6, -22},
{ -6,  22},
{ -5, -22},
{ -5,  22},
{ -4, -22},
{ -4,  22},
{ -3, -22},
{ -3,  22},
{ -2, -22},
{ -2,  22},
{ -1, -22},
{ -1,  22},
{  0, -23},
{  0,  23},
{  1, -22},
{  1,  22},
{  2, -22},
{  2,  22},
{  3, -22},
{  3,  22},
{  4, -22},
{  4,  22},
{  5, -22},
{  5,  22},
{  6, -22},
{  6,  22},
{  7, -21},
{  7,  21},
{  8, -21},
{  8,  21},
{  9, -21},
{  9,  21},
{ 10, -20},
{ 10,  20},
{ 11, -20},
{ 11,  20},
{ 12, -19},
{ 12,  19},
{ 13, -18},
{ 13,  18},
{ 14, -18},
{ 14, -17},
{ 14,  17},
{ 14,  18},
{ 15, -17},
{ 15,  17},
{ 16, -16},
{ 16,  16},
{ 17, -15},
{ 17, -14},
{ 17,  14},
{ 17,  15},
{ 18, -14},
{ 18, -13},
{ 18,  13},
{ 18,  14},
{ 19, -12},
{ 19,  12},
{ 20, -11},
{ 20, -10},
{ 20,  10},
{ 20,  11},
{ 21,  -9},
{ 21,  -8},
{ 21,  -7},
{ 21,   7},
{ 21,   8},
{ 21,   9},
{ 22,  -6},
{ 22,  -5},
{ 22,  -4},
{ 22,  -3},
{ 22,  -2},
{ 22,  -1},
{ 22,   1},
{ 22,   2},
{ 22,   3},
{ 22,   4},
{ 22,   5},
{ 22,   6},
{ 23,   0},
{-24,   0},
{-23,  -6},
{-23,  -5},
{-23,  -4},
{-23,  -3},
{-23,  -2},
{-23,  -1},
{-23,   1},
{-23,   2},
{-23,   3},
{-23,   4},
{-23,   5},
{-23,   6},
{-22,  -9},
{-22,  -8},
{-22,  -7},
{-22,   7},
{-22,   8},
{-22,   9},
{-21, -11},
{-21, -10},
{-21,  10},
{-21,  11},
{-20, -13},
{-20, -12},
{-20,  12},
{-20,  13},
{-19, -14},
{-19, -13},
{-19,  13},
{-19,  14},
{-18, -15},
{-18,  15},
{-17, -16},
{-17,  16},
{-16, -17},
{-16,  17},
{-15, -18},
{-15,  18},
{-14, -19},
{-14,  19},
{-13, -20},
{-13, -19},
{-13,  19},
{-13,  20},
{-12, -20},
{-12,  20},
{-11, -21},
{-11,  21},
{-10, -21},
{-10,  21},
{ -9, -22},
{ -9,  22},
{ -8, -22},
{ -8,  22},
{ -7, -22},
{ -7,  22},
{ -6, -23},
{ -6,  23},
{ -5, -23},
{ -5,  23},
{ -4, -23},
{ -4,  23},
{ -3, -23},
{ -3,  23},
{ -2, -23},
{ -2,  23},
{ -1, -23},
{ -1,  23},
{  0, -24},
{  0,  24},
{  1, -23},
{  1,  23},
{  2, -23},
{  2,  23},
{  3, -23},
{  3,  23},
{  4, -23},
{  4,  23},
{  5, -23},
{  5,  23},
{  6, -23},
{  6,  23},
{  7, -22},
{  7,  22},
{  8, -22},
{  8,  22},
{  9, -22},
{  9,  22},
{ 10, -21},
{ 10,  21},
{ 11, -21},
{ 11,  21},
{ 12, -20},
{ 12,  20},
{ 13, -20},
{ 13, -19},
{ 13,  19},
{ 13,  20},
{ 14, -19},
{ 14,  19},
{ 15, -18},
{ 15,  18},
{ 16, -17},
{ 16,  17},
{ 17, -16},
{ 17,  16},
{ 18, -15},
{ 18,  15},
{ 19, -14},
{ 19, -13},
{ 19,  13},
{ 19,  14},
{ 20, -13},
{ 20, -12},
{ 20,  12},
{ 20,  13},
{ 21, -11},
{ 21, -10},
{ 21,  10},
{ 21,  11},
{ 22,  -9},
{ 22,  -8},
{ 22,  -7},
{ 22,   7},
{ 22,   8},
{ 22,   9},
{ 23,  -6},
{ 23,  -5},
{ 23,  -4},
{ 23,  -3},
{ 23,  -2},
{ 23,  -1},
{ 23,   1},
{ 23,   2},
{ 23,   3},
{ 23,   4},
{ 23,   5},
{ 23,   6},
{ 24,   0},
{-25,   0},
{-24,  -7},
{-24,  -6},
{-24,  -5},
{-24,  -4},
{-24,  -3},
{-24,  -2},
{-24,  -1},
{-24,   1},
{-24,   2},
{-24,   3},
{-24,   4},
{-24,   5},
{-24,   6},
{-24,   7},
{-23,  -9},
{-23,  -8},
{-23,  -7},
{-23,   7},
{-23,   8},
{-23,   9},
{-22, -11},
{-22, -10},
{-22,  10},
{-22,  11},
{-21, -13},
{-21, -12},
{-21,  12},
{-21,  13},
{-20, -15},
{-20, -14},
{-20,  14},
{-20,  15},
{-19, -16},
{-19, -15},
{-19,  15},
{-19,  16},
{-18, -17},
{-18, -16},
{-18,  16},
{-18,  17},
{-17, -18},
{-17, -17},
{-17,  17},
{-17,  18},
{-16, -19},
{-16, -18},
{-16,  18},
{-16,  19},
{-15, -20},
{-15, -19},
{-15,  19},
{-15,  20},
{-14, -20},
{-14,  20},
{-13, -21},
{-13,  21},
{-12, -21},
{-12,  21},
{-11, -22},
{-11,  22},
{-10, -22},
{-10,  22},
{ -9, -23},
{ -9,  23},
{ -8, -23},
{ -8,  23},
{ -7, -24},
{ -7, -23},
{ -7,  23},
{ -7,  24},
{ -6, -24},
{ -6,  24},
{ -5, -24},
{ -5,  24},
{ -4, -24},
{ -4,  24},
{ -3, -24},
{ -3,  24},
{ -2, -24},
{ -2,  24},
{ -1, -24},
{ -1,  24},
{  0, -25},
{  0,  25},
{  1, -24},
{  1,  24},
{  2, -24},
{  2,  24},
{  3, -24},
{  3,  24},
{  4, -24},
{  4,  24},
{  5, -24},
{  5,  24},
{  6, -24},
{  6,  24},
{  7, -24},
{  7, -23},
{  7,  23},
{  7,  24},
{  8, -23},
{  8,  23},
{  9, -23},
{  9,  23},
{ 10, -22},
{ 10,  22},
{ 11, -22},
{ 11,  22},
{ 12, -21},
{ 12,  21},
{ 13, -21},
{ 13,  21},
{ 14, -20},
{ 14,  20},
{ 15, -20},
{ 15, -19},
{ 15,  19},
{ 15,  20},
{ 16, -19},
{ 16, -18},
{ 16,  18},
{ 16,  19},
{ 17, -18},
{ 17, -17},
{ 17,  17},
{ 17,  18},
{ 18, -17},
{ 18, -16},
{ 18,  16},
{ 18,  17},
{ 19, -16},
{ 19, -15},
{ 19,  15},
{ 19,  16},
{ 20, -15},
{ 20, -14},
{ 20,  14},
{ 20,  15},
{ 21, -13},
{ 21, -12},
{ 21,  12},
{ 21,  13},
{ 22, -11},
{ 22, -10},
{ 22,  10},
{ 22,  11},
{ 23,  -9},
{ 23,  -8},
{ 23,  -7},
{ 23,   7},
{ 23,   8},
{ 23,   9},
{ 24,  -7},
{ 24,  -6},
{ 24,  -5},
{ 24,  -4},
{ 24,  -3},
{ 24,  -2},
{ 24,  -1},
{ 24,   1},
{ 24,   2},
{ 24,   3},
{ 24,   4},
{ 24,   5},
{ 24,   6},
{ 24,   7},
{ 25,   0},
{-26,   0},
{-25,  -7},
{-25,  -6},
{-25,  -5},
{-25,  -4},
{-25,  -3},
{-25,  -2},
{-25,  -1},
{-25,   1},
{-25,   2},
{-25,   3},
{-25,   4},
{-25,   5},
{-25,   6},
{-25,   7},
{-24, -10},
{-24,  -9},
{-24,  -8},
{-24,   8},
{-24,   9},
{-24,  10},
{-23, -12},
{-23, -11},
{-23, -10},
{-23,  10},
{-23,  11},
{-23,  12},
{-22, -13},
{-22, -12},
{-22,  12},
{-22,  13},
{-21, -15},
{-21, -14},
{-21,  14},
{-21,  15},
{-20, -16},
{-20,  16},
{-19, -17},
{-19,  17},
{-18, -18},
{-18,  18},
{-17, -19},
{-17,  19},
{-16, -20},
{-16,  20},
{-15, -21},
{-15,  21},
{-14, -21},
{-14,  21},
{-13, -22},
{-13,  22},
{-12, -23},
{-12, -22},
{-12,  22},
{-12,  23},
{-11, -23},
{-11,  23},
{-10, -24},
{-10, -23},
{-10,  23},
{-10,  24},
{ -9, -24},
{ -9,  24},
{ -8, -24},
{ -8,  24},
{ -7, -25},
{ -7,  25},
{ -6, -25},
{ -6,  25},
{ -5, -25},
{ -5,  25},
{ -4, -25},
{ -4,  25},
{ -3, -25},
{ -3,  25},
{ -2, -25},
{ -2,  25},
{ -1, -25},
{ -1,  25},
{  0, -26},
{  0,  26},
{  1, -25},
{  1,  25},
{  2, -25},
{  2,  25},
{  3, -25},
{  3,  25},
{  4, -25},
{  4,  25},
{  5, -25},
{  5,  25},
{  6, -25},
{  6,  25},
{  7, -25},
{  7,  25},
{  8, -24},
{  8,  24},
{  9, -24},
{  9,  24},
{ 10, -24},
{ 10, -23},
{ 10,  23},
{ 10,  24},
{ 11, -23},
{ 11,  23},
{ 12, -23},
{ 12, -22},
{ 12,  22},
{ 12,  23},
{ 13, -22},
{ 13,  22},
{ 14, -21},
{ 14,  21},
{ 15, -21},
{ 15,  21},
{ 16, -20},
{ 16,  20},
{ 17, -19},
{ 17,  19},
{ 18, -18},
{ 18,  18},
{ 19, -17},
{ 19,  17},
{ 20, -16},
{ 20,  16},
{ 21, -15},
{ 21, -14},
{ 21,  14},
{ 21,  15},
{ 22, -13},
{ 22, -12},
{ 22,  12},
{ 22,  13},
{ 23, -12},
{ 23, -11},
{ 23, -10},
{ 23,  10},
{ 23,  11},
{ 23,  12},
{ 24, -10},
{ 24,  -9},
{ 24,  -8},
{ 24,   8},
{ 24,   9},
{ 24,  10},
{ 25,  -7},
{ 25,  -6},
{ 25,  -5},
{ 25,  -4},
{ 25,  -3},
{ 25,  -2},
{ 25,  -1},
{ 25,   1},
{ 25,   2},
{ 25,   3},
{ 25,   4},
{ 25,   5},
{ 25,   6},
{ 25,   7},
{ 26,   0},
{-27,   0},
{-26,  -7},
{-26,  -6},
{-26,  -5},
{-26,  -4},
{-26,  -3},
{-26,  -2},
{-26,  -1},
{-26,   1},
{-26,   2},
{-26,   3},
{-26,   4},
{-26,   5},
{-26,   6},
{-26,   7},
{-25, -10},
{-25,  -9},
{-25,  -8},
{-25,   8},
{-25,   9},
{-25,  10},
{-24, -12},
{-24, -11},
{-24,  11},
{-24,  12},
{-23, -14},
{-23, -13},
{-23,  13},
{-23,  14},
{-22, -15},
{-22, -14},
{-22,  14},
{-22,  15},
{-21, -16},
{-21,  16},
{-20, -18},
{-20, -17},
{-20,  17},
{-20,  18},
{-19, -19},
{-19, -18},
{-19,  18},
{-19,  19},
{-18, -20},
{-18, -19},
{-18,  19},
{-18,  20},
{-17, -20},
{-17,  20},
{-16, -21},
{-16,  21},
{-15, -22},
{-15,  22},
{-14, -23},
{-14, -22},
{-14,  22},
{-14,  23},
{-13, -23},
{-13,  23},
{-12, -24},
{-12,  24},
{-11, -24},
{-11,  24},
{-10, -25},
{-10,  25},
{ -9, -25},
{ -9,  25},
{ -8, -25},
{ -8,  25},
{ -7, -26},
{ -7,  26},
{ -6, -26},
{ -6,  26},
{ -5, -26},
{ -5,  26},
{ -4, -26},
{ -4,  26},
{ -3, -26},
{ -3,  26},
{ -2, -26},
{ -2,  26},
{ -1, -26},
{ -1,  26},
{  0, -27},
{  0,  27},
{  1, -26},
{  1,  26},
{  2, -26},
{  2,  26},
{  3, -26},
{  3,  26},
{  4, -26},
{  4,  26},
{  5, -26},
{  5,  26},
{  6, -26},
{  6,  26},
{  7, -26},
{  7,  26},
{  8, -25},
{  8,  25},
{  9, -25},
{  9,  25},
{ 10, -25},
{ 10,  25},
{ 11, -24},
{ 11,  24},
{ 12, -24},
{ 12,  24},
{ 13, -23},
{ 13,  23},
{ 14, -23},
{ 14, -22},
{ 14,  22},
{ 14,  23},
{ 15, -22},
{ 15,  22},
{ 16, -21},
{ 16,  21},
{ 17, -20},
{ 17,  20},
{ 18, -20},
{ 18, -19},
{ 18,  19},
{ 18,  20},
{ 19, -19},
{ 19, -18},
{ 19,  18},
{ 19,  19},
{ 20, -18},
{ 20, -17},
{ 20,  17},
{ 20,  18},
{ 21, -16},
{ 21,  16},
{ 22, -15},
{ 22, -14},
{ 22,  14},
{ 22,  15},
{ 23, -14},
{ 23, -13},
{ 23,  13},
{ 23,  14},
{ 24, -12},
{ 24, -11},
{ 24,  11},
{ 24,  12},
{ 25, -10},
{ 25,  -9},
{ 25,  -8},
{ 25,   8},
{ 25,   9},
{ 25,  10},
{ 26,  -7},
{ 26,  -6},
{ 26,  -5},
{ 26,  -4},
{ 26,  -3},
{ 26,  -2},
{ 26,  -1},
{ 26,   1},
{ 26,   2},
{ 26,   3},
{ 26,   4},
{ 26,   5},
{ 26,   6},
{ 26,   7},
{ 27,   0},
{-28,   0},
{-27,  -7},
{-27,  -6},
{-27,  -5},
{-27,  -4},
{-27,  -3},
{-27,  -2},
{-27,  -1},
{-27,   1},
{-27,   2},
{-27,   3},
{-27,   4},
{-27,   5},
{-27,   6},
{-27,   7},
{-26, -10},
{-26,  -9},
{-26,  -8},
{-26,   8},
{-26,   9},
{-26,  10},
{-25, -12},
{-25, -11},
{-25,  11},
{-25,  12},
{-24, -14},
{-24, -13},
{-24,  13},
{-24,  14},
{-23, -15},
{-23,  15},
{-22, -17},
{-22, -16},
{-22,  16},
{-22,  17},
{-21, -18},
{-21, -17},
{-21,  17},
{-21,  18},
{-20, -19},
{-20,  19},
{-19, -20},
{-19,  20},
{-18, -21},
{-18,  21},
{-17, -22},
{-17, -21},
{-17,  21},
{-17,  22},
{-16, -22},
{-16,  22},
{-15, -23},
{-15,  23},
{-14, -24},
{-14,  24},
{-13, -24},
{-13,  24},
{-12, -25},
{-12,  25},
{-11, -25},
{-11,  25},
{-10, -26},
{-10,  26},
{ -9, -26},
{ -9,  26},
{ -8, -26},
{ -8,  26},
{ -7, -27},
{ -7,  27},
{ -6, -27},
{ -6,  27},
{ -5, -27},
{ -5,  27},
{ -4, -27},
{ -4,  27},
{ -3, -27},
{ -3,  27},
{ -2, -27},
{ -2,  27},
{ -1, -27},
{ -1,  27},
{  0, -28},
{  0,  28},
{  1, -27},
{  1,  27},
{  2, -27},
{  2,  27},
{  3, -27},
{  3,  27},
{  4, -27},
{  4,  27},
{  5, -27},
{  5,  27},
{  6, -27},
{  6,  27},
{  7, -27},
{  7,  27},
{  8, -26},
{  8,  26},
{  9, -26},
{  9,  26},
{ 10, -26},
{ 10,  26},
{ 11, -25},
{ 11,  25},
{ 12, -25},
{ 12,  25},
{ 13, -24},
{ 13,  24},
{ 14, -24},
{ 14,  24},
{ 15, -23},
{ 15,  23},
{ 16, -22},
{ 16,  22},
{ 17, -22},
{ 17, -21},
{ 17,  21},
{ 17,  22},
{ 18, -21},
{ 18,  21},
{ 19, -20},
{ 19,  20},
{ 20, -19},
{ 20,  19},
{ 21, -18},
{ 21, -17},
{ 21,  17},
{ 21,  18},
{ 22, -17},
{ 22, -16},
{ 22,  16},
{ 22,  17},
{ 23, -15},
{ 23,  15},
{ 24, -14},
{ 24, -13},
{ 24,  13},
{ 24,  14},
{ 25, -12},
{ 25, -11},
{ 25,  11},
{ 25,  12},
{ 26, -10},
{ 26,  -9},
{ 26,  -8},
{ 26,   8},
{ 26,   9},
{ 26,  10},
{ 27,  -7},
{ 27,  -6},
{ 27,  -5},
{ 27,  -4},
{ 27,  -3},
{ 27,  -2},
{ 27,  -1},
{ 27,   1},
{ 27,   2},
{ 27,   3},
{ 27,   4},
{ 27,   5},
{ 27,   6},
{ 27,   7},
{ 28,   0},
{-29,   0},
{-28,  -7},
{-28,  -6},
{-28,  -5},
{-28,  -4},
{-28,  -3},
{-28,  -2},
{-28,  -1},
{-28,   1},
{-28,   2},
{-28,   3},
{-28,   4},
{-28,   5},
{-28,   6},
{-28,   7},
{-27, -10},
{-27,  -9},
{-27,  -8},
{-27,   8},
{-27,   9},
{-27,  10},
{-26, -12},
{-26, -11},
{-26,  11},
{-26,  12},
{-25, -14},
{-25, -13},
{-25,  13},
{-25,  14},
{-24, -16},
{-24, -15},
{-24,  15},
{-24,  16},
{-23, -17},
{-23, -16},
{-23,  16},
{-23,  17},
{-22, -18},
{-22,  18},
{-21, -20},
{-21, -19},
{-21,  19},
{-21,  20},
{-20, -21},
{-20, -20},
{-20,  20},
{-20,  21},
{-19, -21},
{-19,  21},
{-18, -22},
{-18,  22},
{-17, -23},
{-17,  23},
{-16, -24},
{-16, -23},
{-16,  23},
{-16,  24},
{-15, -24},
{-15,  24},
{-14, -25},
{-14,  25},
{-13, -25},
{-13,  25},
{-12, -26},
{-12,  26},
{-11, -26},
{-11,  26},
{-10, -27},
{-10,  27},
{ -9, -27},
{ -9,  27},
{ -8, -27},
{ -8,  27},
{ -7, -28},
{ -7,  28},
{ -6, -28},
{ -6,  28},
{ -5, -28},
{ -5,  28},
{ -4, -28},
{ -4,  28},
{ -3, -28},
{ -3,  28},
{ -2, -28},
{ -2,  28},
{ -1, -28},
{ -1,  28},
{  0, -29},
{  0,  29},
{  1, -28},
{  1,  28},
{  2, -28},
{  2,  28},
{  3, -28},
{  3,  28},
{  4, -28},
{  4,  28},
{  5, -28},
{  5,  28},
{  6, -28},
{  6,  28},
{  7, -28},
{  7,  28},
{  8, -27},
{  8,  27},
{  9, -27},
{  9,  27},
{ 10, -27},
{ 10,  27},
{ 11, -26},
{ 11,  26},
{ 12, -26},
{ 12,  26},
{ 13, -25},
{ 13,  25},
{ 14, -25},
{ 14,  25},
{ 15, -24},
{ 15,  24},
{ 16, -24},
{ 16, -23},
{ 16,  23},
{ 16,  24},
{ 17, -23},
{ 17,  23},
{ 18, -22},
{ 18,  22},
{ 19, -21},
{ 19,  21},
{ 20, -21},
{ 20, -20},
{ 20,  20},
{ 20,  21},
{ 21, -20},
{ 21, -19},
{ 21,  19},
{ 21,  20},
{ 22, -18},
{ 22,  18},
{ 23, -17},
{ 23, -16},
{ 23,  16},
{ 23,  17},
{ 24, -16},
{ 24, -15},
{ 24,  15},
{ 24,  16},
{ 25, -14},
{ 25, -13},
{ 25,  13},
{ 25,  14},
{ 26, -12},
{ 26, -11},
{ 26,  11},
{ 26,  12},
{ 27, -10},
{ 27,  -9},
{ 27,  -8},
{ 27,   8},
{ 27,   9},
{ 27,  10},
{ 28,  -7},
{ 28,  -6},
{ 28,  -5},
{ 28,  -4},
{ 28,  -3},
{ 28,  -2},
{ 28,  -1},
{ 28,   1},
{ 28,   2},
{ 28,   3},
{ 28,   4},
{ 28,   5},
{ 28,   6},
{ 28,   7},
{ 29,   0},
{-30,   0},
{-29,  -7},
{-29,  -6},
{-29,  -5},
{-29,  -4},
{-29,  -3},
{-29,  -2},
{-29,  -1},
{-29,   1},
{-29,   2},
{-29,   3},
{-29,   4},
{-29,   5},
{-29,   6},
{-29,   7},
{-28, -10},
{-28,  -9},
{-28,  -8},
{-28,   8},
{-28,   9},
{-28,  10},
{-27, -13},
{-27, -12},
{-27, -11},
{-27,  11},
{-27,  12},
{-27,  13},
{-26, -14},
{-26, -13},
{-26,  13},
{-26,  14},
{-25, -16},
{-25, -15},
{-25,  15},
{-25,  16},
{-24, -18},
{-24, -17},
{-24,  17},
{-24,  18},
{-23, -19},
{-23, -18},
{-23,  18},
{-23,  19},
{-22, -20},
{-22, -19},
{-22,  19},
{-22,  20},
{-21, -21},
{-21,  21},
{-20, -22},
{-20,  22},
{-19, -23},
{-19, -22},
{-19,  22},
{-19,  23},
{-18, -24},
{-18, -23},
{-18,  23},
{-18,  24},
{-17, -24},
{-17,  24},
{-16, -25},
{-16,  25},
{-15, -25},
{-15,  25},
{-14, -26},
{-14,  26},
{-13, -27},
{-13, -26},
{-13,  26},
{-13,  27},
{-12, -27},
{-12,  27},
{-11, -27},
{-11,  27},
{-10, -28},
{-10,  28},
{ -9, -28},
{ -9,  28},
{ -8, -28},
{ -8,  28},
{ -7, -29},
{ -7,  29},
{ -6, -29},
{ -6,  29},
{ -5, -29},
{ -5,  29},
{ -4, -29},
{ -4,  29},
{ -3, -29},
{ -3,  29},
{ -2, -29},
{ -2,  29},
{ -1, -29},
{ -1,  29},
{  0, -30},
{  0,  30},
{  1, -29},
{  1,  29},
{  2, -29},
{  2,  29},
{  3, -29},
{  3,  29},
{  4, -29},
{  4,  29},
{  5, -29},
{  5,  29},
{  6, -29},
{  6,  29},
{  7, -29},
{  7,  29},
{  8, -28},
{  8,  28},
{  9, -28},
{  9,  28},
{ 10, -28},
{ 10,  28},
{ 11, -27},
{ 11,  27},
{ 12, -27},
{ 12,  27},
{ 13, -27},
{ 13, -26},
{ 13,  26},
{ 13,  27},
{ 14, -26},
{ 14,  26},
{ 15, -25},
{ 15,  25},
{ 16, -25},
{ 16,  25},
{ 17, -24},
{ 17,  24},
{ 18, -24},
{ 18, -23},
{ 18,  23},
{ 18,  24},
{ 19, -23},
{ 19, -22},
{ 19,  22},
{ 19,  23},
{ 20, -22},
{ 20,  22},
{ 21, -21},
{ 21,  21},
{ 22, -20},
{ 22, -19},
{ 22,  19},
{ 22,  20},
{ 23, -19},
{ 23, -18},
{ 23,  18},
{ 23,  19},
{ 24, -18},
{ 24, -17},
{ 24,  17},
{ 24,  18},
{ 25, -16},
{ 25, -15},
{ 25,  15},
{ 25,  16},
{ 26, -14},
{ 26, -13},
{ 26,  13},
{ 26,  14},
{ 27, -13},
{ 27, -12},
{ 27, -11},
{ 27,  11},
{ 27,  12},
{ 27,  13},
{ 28, -10},
{ 28,  -9},
{ 28,  -8},
{ 28,   8},
{ 28,   9},
{ 28,  10},
{ 29,  -7},
{ 29,  -6},
{ 29,  -5},
{ 29,  -4},
{ 29,  -3},
{ 29,  -2},
{ 29,  -1},
{ 29,   1},
{ 29,   2},
{ 29,   3},
{ 29,   4},
{ 29,   5},
{ 29,   6},
{ 29,   7},
{ 30,   0},
{-31,   0},
{-30,  -7},
{-30,  -6},
{-30,  -5},
{-30,  -4},
{-30,  -3},
{-30,  -2},
{-30,  -1},
{-30,   1},
{-30,   2},
{-30,   3},
{-30,   4},
{-30,   5},
{-30,   6},
{-30,   7},
{-29, -10},
{-29,  -9},
{-29,  -8},
{-29,   8},
{-29,   9},
{-29,  10},
{-28, -13},
{-28, -12},
{-28, -11},
{-28,  11},
{-28,  12},
{-28,  13},
{-27, -15},
{-27, -14},
{-27,  14},
{-27,  15},
{-26, -16},
{-26, -15},
{-26,  15},
{-26,  16},
{-25, -18},
{-25, -17},
{-25,  17},
{-25,  18},
{-24, -19},
{-24,  19},
{-23, -20},
{-23,  20},
{-22, -21},
{-22,  21},
{-21, -22},
{-21,  22},
{-20, -23},
{-20,  23},
{-19, -24},
{-19,  24},
{-18, -25},
{-18,  25},
{-17, -25},
{-17,  25},
{-16, -26},
{-16,  26},
{-15, -27},
{-15, -26},
{-15,  26},
{-15,  27},
{-14, -27},
{-14,  27},
{-13, -28},
{-13,  28},
{-12, -28},
{-12,  28},
{-11, -28},
{-11,  28},
{-10, -29},
{-10,  29},
{ -9, -29},
{ -9,  29},
{ -8, -29},
{ -8,  29},
{ -7, -30},
{ -7,  30},
{ -6, -30},
{ -6,  30},
{ -5, -30},
{ -5,  30},
{ -4, -30},
{ -4,  30},
{ -3, -30},
{ -3,  30},
{ -2, -30},
{ -2,  30},
{ -1, -30},
{ -1,  30},
{  0, -31},
{  0,  31},
{  1, -30},
{  1,  30},
{  2, -30},
{  2,  30},
{  3, -30},
{  3,  30},
{  4, -30},
{  4,  30},
{  5, -30},
{  5,  30},
{  6, -30},
{  6,  30},
{  7, -30},
{  7,  30},
{  8, -29},
{  8,  29},
{  9, -29},
{  9,  29},
{ 10, -29},
{ 10,  29},
{ 11, -28},
{ 11,  28},
{ 12, -28},
{ 12,  28},
{ 13, -28},
{ 13,  28},
{ 14, -27},
{ 14,  27},
{ 15, -27},
{ 15, -26},
{ 15,  26},
{ 15,  27},
{ 16, -26},
{ 16,  26},
{ 17, -25},
{ 17,  25},
{ 18, -25},
{ 18,  25},
{ 19, -24},
{ 19,  24},
{ 20, -23},
{ 20,  23},
{ 21, -22},
{ 21,  22},
{ 22, -21},
{ 22,  21},
{ 23, -20},
{ 23,  20},
{ 24, -19},
{ 24,  19},
{ 25, -18},
{ 25, -17},
{ 25,  17},
{ 25,  18},
{ 26, -16},
{ 26, -15},
{ 26,  15},
{ 26,  16},
{ 27, -15},
{ 27, -14},
{ 27,  14},
{ 27,  15},
{ 28, -13},
{ 28, -12},
{ 28, -11},
{ 28,  11},
{ 28,  12},
{ 28,  13},
{ 29, -10},
{ 29,  -9},
{ 29,  -8},
{ 29,   8},
{ 29,   9},
{ 29,  10},
{ 30,  -7},
{ 30,  -6},
{ 30,  -5},
{ 30,  -4},
{ 30,  -3},
{ 30,  -2},
{ 30,  -1},
{ 30,   1},
{ 30,   2},
{ 30,   3},
{ 30,   4},
{ 30,   5},
{ 30,   6},
{ 30,   7},
{ 31,   0},
{-32,   0},
{-31,  -7},
{-31,  -6},
{-31,  -5},
{-31,  -4},
{-31,  -3},
{-31,  -2},
{-31,  -1},
{-31,   1},
{-31,   2},
{-31,   3},
{-31,   4},
{-31,   5},
{-31,   6},
{-31,   7},
{-30, -11},
{-30, -10},
{-30,  -9},
{-30,  -8},
{-30,   8},
{-30,   9},
{-30,  10},
{-30,  11},
{-29, -13},
{-29, -12},
{-29, -11},
{-29,  11},
{-29,  12},
{-29,  13},
{-28, -15},
{-28, -14},
{-28,  14},
{-28,  15},
{-27, -17},
{-27, -16},
{-27,  16},
{-27,  17},
{-26, -18},
{-26, -17},
{-26,  17},
{-26,  18},
{-25, -19},
{-25,  19},
{-24, -21},
{-24, -20},
{-24,  20},
{-24,  21},
{-23, -22},
{-23, -21},
{-23,  21},
{-23,  22},
{-22, -23},
{-22, -22},
{-22,  22},
{-22,  23},
{-21, -24},
{-21, -23},
{-21,  23},
{-21,  24},
{-20, -24},
{-20,  24},
{-19, -25},
{-19,  25},
{-18, -26},
{-18,  26},
{-17, -27},
{-17, -26},
{-17,  26},
{-17,  27},
{-16, -27},
{-16,  27},
{-15, -28},
{-15,  28},
{-14, -28},
{-14,  28},
{-13, -29},
{-13,  29},
{-12, -29},
{-12,  29},
{-11, -30},
{-11, -29},
{-11,  29},
{-11,  30},
{-10, -30},
{-10,  30},
{ -9, -30},
{ -9,  30},
{ -8, -30},
{ -8,  30},
{ -7, -31},
{ -7,  31},
{ -6, -31},
{ -6,  31},
{ -5, -31},
{ -5,  31},
{ -4, -31},
{ -4,  31},
{ -3, -31},
{ -3,  31},
{ -2, -31},
{ -2,  31},
{ -1, -31},
{ -1,  31},
{  0, -32},
{  0,  32},
{  1, -31},
{  1,  31},
{  2, -31},
{  2,  31},
{  3, -31},
{  3,  31},
{  4, -31},
{  4,  31},
{  5, -31},
{  5,  31},
{  6, -31},
{  6,  31},
{  7, -31},
{  7,  31},
{  8, -30},
{  8,  30},
{  9, -30},
{  9,  30},
{ 10, -30},
{ 10,  30},
{ 11, -30},
{ 11, -29},
{ 11,  29},
{ 11,  30},
{ 12, -29},
{ 12,  29},
{ 13, -29},
{ 13,  29},
{ 14, -28},
{ 14,  28},
{ 15, -28},
{ 15,  28},
{ 16, -27},
{ 16,  27},
{ 17, -27},
{ 17, -26},
{ 17,  26},
{ 17,  27},
{ 18, -26},
{ 18,  26},
{ 19, -25},
{ 19,  25},
{ 20, -24},
{ 20,  24},
{ 21, -24},
{ 21, -23},
{ 21,  23},
{ 21,  24},
{ 22, -23},
{ 22, -22},
{ 22,  22},
{ 22,  23},
{ 23, -22},
{ 23, -21},
{ 23,  21},
{ 23,  22},
{ 24, -21},
{ 24, -20},
{ 24,  20},
{ 24,  21},
{ 25, -19},
{ 25,  19},
{ 26, -18},
{ 26, -17},
{ 26,  17},
{ 26,  18},
{ 27, -17},
{ 27, -16},
{ 27,  16},
{ 27,  17},
{ 28, -15},
{ 28, -14},
{ 28,  14},
{ 28,  15},
{ 29, -13},
{ 29, -12},
{ 29, -11},
{ 29,  11},
{ 29,  12},
{ 29,  13},
{ 30, -11},
{ 30, -10},
{ 30,  -9},
{ 30,  -8},
{ 30,   8},
{ 30,   9},
{ 30,  10},
{ 30,  11},
{ 31,  -7},
{ 31,  -6},
{ 31,  -5},
{ 31,  -4},
{ 31,  -3},
{ 31,  -2},
{ 31,  -1},
{ 31,   1},
{ 31,   2},
{ 31,   3},
{ 31,   4},
{ 31,   5},
{ 31,   6},
{ 31,   7},
{ 32,   0},
{-33,   0},
{-32,  -8},
{-32,  -7},
{-32,  -6},
{-32,  -5},
{-32,  -4},
{-32,  -3},
{-32,  -2},
{-32,  -1},
{-32,   1},
{-32,   2},
{-32,   3},
{-32,   4},
{-32,   5},
{-32,   6},
{-32,   7},
{-32,   8},
{-31, -11},
{-31, -10},
{-31,  -9},
{-31,  -8},
{-31,   8},
{-31,   9},
{-31,  10},
{-31,  11},
{-30, -13},
{-30, -12},
{-30,  12},
{-30,  13},
{-29, -15},
{-29, -14},
{-29,  14},
{-29,  15},
{-28, -17},
{-28, -16},
{-28,  16},
{-28,  17},
{-27, -18},
{-27,  18},
{-26, -20},
{-26, -19},
{-26,  19},
{-26,  20},
{-25, -21},
{-25, -20},
{-25,  20},
{-25,  21},
{-24, -22},
{-24,  22},
{-23, -23},
{-23,  23},
{-22, -24},
{-22,  24},
{-21, -25},
{-21,  25},
{-20, -26},
{-20, -25},
{-20,  25},
{-20,  26},
{-19, -26},
{-19,  26},
{-18, -27},
{-18,  27},
{-17, -28},
{-17,  28},
{-16, -28},
{-16,  28},
{-15, -29},
{-15,  29},
{-14, -29},
{-14,  29},
{-13, -30},
{-13,  30},
{-12, -30},
{-12,  30},
{-11, -31},
{-11,  31},
{-10, -31},
{-10,  31},
{ -9, -31},
{ -9,  31},
{ -8, -32},
{ -8, -31},
{ -8,  31},
{ -8,  32},
{ -7, -32},
{ -7,  32},
{ -6, -32},
{ -6,  32},
{ -5, -32},
{ -5,  32},
{ -4, -32},
{ -4,  32},
{ -3, -32},
{ -3,  32},
{ -2, -32},
{ -2,  32},
{ -1, -32},
{ -1,  32},
{  0, -33},
{  0,  33},
{  1, -32},
{  1,  32},
{  2, -32},
{  2,  32},
{  3, -32},
{  3,  32},
{  4, -32},
{  4,  32},
{  5, -32},
{  5,  32},
{  6, -32},
{  6,  32},
{  7, -32},
{  7,  32},
{  8, -32},
{  8, -31},
{  8,  31},
{  8,  32},
{  9, -31},
{  9,  31},
{ 10, -31},
{ 10,  31},
{ 11, -31},
{ 11,  31},
{ 12, -30},
{ 12,  30},
{ 13, -30},
{ 13,  30},
{ 14, -29},
{ 14,  29},
{ 15, -29},
{ 15,  29},
{ 16, -28},
{ 16,  28},
{ 17, -28},
{ 17,  28},
{ 18, -27},
{ 18,  27},
{ 19, -26},
{ 19,  26},
{ 20, -26},
{ 20, -25},
{ 20,  25},
{ 20,  26},
{ 21, -25},
{ 21,  25},
{ 22, -24},
{ 22,  24},
{ 23, -23},
{ 23,  23},
{ 24, -22},
{ 24,  22},
{ 25, -21},
{ 25, -20},
{ 25,  20},
{ 25,  21},
{ 26, -20},
{ 26, -19},
{ 26,  19},
{ 26,  20},
{ 27, -18},
{ 27,  18},
{ 28, -17},
{ 28, -16},
{ 28,  16},
{ 28,  17},
{ 29, -15},
{ 29, -14},
{ 29,  14},
{ 29,  15},
{ 30, -13},
{ 30, -12},
{ 30,  12},
{ 30,  13},
{ 31, -11},
{ 31, -10},
{ 31,  -9},
{ 31,  -8},
{ 31,   8},
{ 31,   9},
{ 31,  10},
{ 31,  11},
{ 32,  -8},
{ 32,  -7},
{ 32,  -6},
{ 32,  -5},
{ 32,  -4},
{ 32,  -3},
{ 32,  -2},
{ 32,  -1},
{ 32,   1},
{ 32,   2},
{ 32,   3},
{ 32,   4},
{ 32,   5},
{ 32,   6},
{ 32,   7},
{ 32,   8},
{ 33,   0},
{-34,   0},
{-33,  -8},
{-33,  -7},
{-33,  -6},
{-33,  -5},
{-33,  -4},
{-33,  -3},
{-33,  -2},
{-33,  -1},
{-33,   1},
{-33,   2},
{-33,   3},
{-33,   4},
{-33,   5},
{-33,   6},
{-33,   7},
{-33,   8},
{-32, -11},
{-32, -10},
{-32,  -9},
{-32,   9},
{-32,  10},
{-32,  11},
{-31, -13},
{-31, -12},
{-31,  12},
{-31,  13},
{-30, -16},
{-30, -15},
{-30, -14},
{-30,  14},
{-30,  15},
{-30,  16},
{-29, -17},
{-29, -16},
{-29,  16},
{-29,  17},
{-28, -19},
{-28, -18},
{-28,  18},
{-28,  19},
{-27, -20},
{-27, -19},
{-27,  19},
{-27,  20},
{-26, -21},
{-26,  21},
{-25, -23},
{-25, -22},
{-25,  22},
{-25,  23},
{-24, -24},
{-24, -23},
{-24,  23},
{-24,  24},
{-23, -25},
{-23, -24},
{-23,  24},
{-23,  25},
{-22, -25},
{-22,  25},
{-21, -26},
{-21,  26},
{-20, -27},
{-20,  27},
{-19, -28},
{-19, -27},
{-19,  27},
{-19,  28},
{-18, -28},
{-18,  28},
{-17, -29},
{-17,  29},
{-16, -30},
{-16, -29},
{-16,  29},
{-16,  30},
{-15, -30},
{-15,  30},
{-14, -30},
{-14,  30},
{-13, -31},
{-13,  31},
{-12, -31},
{-12,  31},
{-11, -32},
{-11,  32},
{-10, -32},
{-10,  32},
{ -9, -32},
{ -9,  32},
{ -8, -33},
{ -8,  33},
{ -7, -33},
{ -7,  33},
{ -6, -33},
{ -6,  33},
{ -5, -33},
{ -5,  33},
{ -4, -33},
{ -4,  33},
{ -3, -33},
{ -3,  33},
{ -2, -33},
{ -2,  33},
{ -1, -33},
{ -1,  33},
{  0, -34},
{  0,  34},
{  1, -33},
{  1,  33},
{  2, -33},
{  2,  33},
{  3, -33},
{  3,  33},
{  4, -33},
{  4,  33},
{  5, -33},
{  5,  33},
{  6, -33},
{  6,  33},
{  7, -33},
{  7,  33},
{  8, -33},
{  8,  33},
{  9, -32},
{  9,  32},
{ 10, -32},
{ 10,  32},
{ 11, -32},
{ 11,  32},
{ 12, -31},
{ 12,  31},
{ 13, -31},
{ 13,  31},
{ 14, -30},
{ 14,  30},
{ 15, -30},
{ 15,  30},
{ 16, -30},
{ 16, -29},
{ 16,  29},
{ 16,  30},
{ 17, -29},
{ 17,  29},
{ 18, -28},
{ 18,  28},
{ 19, -28},
{ 19, -27},
{ 19,  27},
{ 19,  28},
{ 20, -27},
{ 20,  27},
{ 21, -26},
{ 21,  26},
{ 22, -25},
{ 22,  25},
{ 23, -25},
{ 23, -24},
{ 23,  24},
{ 23,  25},
{ 24, -24},
{ 24, -23},
{ 24,  23},
{ 24,  24},
{ 25, -23},
{ 25, -22},
{ 25,  22},
{ 25,  23},
{ 26, -21},
{ 26,  21},
{ 27, -20},
{ 27, -19},
{ 27,  19},
{ 27,  20},
{ 28, -19},
{ 28, -18},
{ 28,  18},
{ 28,  19},
{ 29, -17},
{ 29, -16},
{ 29,  16},
{ 29,  17},
{ 30, -16},
{ 30, -15},
{ 30, -14},
{ 30,  14},
{ 30,  15},
{ 30,  16},
{ 31, -13},
{ 31, -12},
{ 31,  12},
{ 31,  13},
{ 32, -11},
{ 32, -10},
{ 32,  -9},
{ 32,   9},
{ 32,  10},
{ 32,  11},
{ 33,  -8},
{ 33,  -7},
{ 33,  -6},
{ 33,  -5},
{ 33,  -4},
{ 33,  -3},
{ 33,  -2},
{ 33,  -1},
{ 33,   1},
{ 33,   2},
{ 33,   3},
{ 33,   4},
{ 33,   5},
{ 33,   6},
{ 33,   7},
{ 33,   8},
{ 34,   0}};
